﻿Imports System.Runtime.InteropServices

Public Class RichTextBoxSpellCheck
    Inherits RichTextBox

#Region "API"
    <DllImport("user32.dll", CharSet:=CharSet.Auto)>
    Private Shared Function SendMessage(<[In]> hWnd As IntPtr,
                                        <[In]> uMsg As Integer,
                                        <[In]> wParam As Integer,
                                        <[In]> lParam As IntPtr) As IntPtr
    End Function
#End Region

#Region "Const"
    Private Const WM_USER As Integer = &H400
    Private Const EM_SETLANGOPTIONS As Integer = WM_USER + 120
    Private Const EM_GETLANGOPTIONS As Integer = WM_USER + 121
    Private Const EM_SETEDITSTYLE As Integer = WM_USER + 204
    Private Const EM_GETEDITSTYLE As Integer = WM_USER + 205
    Private Const IMF_SPELLCHECKING As Integer = &H800
    Private Const IMF_TKBPREDICTION As Integer = &H1000
    Private Const IMF_TKBAUTOCORRECTION As Integer = &H2000
    Private Const SES_USECTF As Integer = &H10000
    Private Const SES_CTFALLOWEMBED As Integer = &H200000
    Private Const SES_CTFALLOWSMARTTAG As Integer = &H400000
    Private Const SES_CTFALLOWPROOFING As Integer = &H800000
#End Region

    Protected Overrides Sub OnHandleCreated(ByVal e As EventArgs)
        MyBase.OnHandleCreated(e)
        If Environment.OSVersion.Version.Major > 6 OrElse Environment.OSVersion.Version.Major = 6 AndAlso Environment.OSVersion.Version.Minor >= 2 Then

            Dim intCurrLangOptions As Integer = CInt(SendMessage(Me.Handle, EM_GETLANGOPTIONS, 0, IntPtr.Zero))
            Dim intCurrEditOptions As Integer = CInt(SendMessage(Me.Handle, EM_GETEDITSTYLE, 0, IntPtr.Zero))
            SendMessage(Me.Handle, EM_SETLANGOPTIONS, 0, New IntPtr(intCurrLangOptions Or
                                                                    IMF_SPELLCHECKING Or
                                                                    IMF_TKBPREDICTION Or
                                                                    IMF_TKBAUTOCORRECTION))

            SendMessage(Me.Handle, EM_SETEDITSTYLE, 0, New IntPtr(intCurrEditOptions Or
                                                                  SES_USECTF Or
                                                                  SES_CTFALLOWEMBED Or
                                                                  SES_CTFALLOWSMARTTAG Or
                                                                  SES_CTFALLOWPROOFING))
        End If
    End Sub

End Class
